SystemOrganization addCategory: #'Ma base additions-File services'!
SystemOrganization addCategory: #'Ma base additions-Info'!
SystemOrganization addCategory: #'Ma base additions-abstractions'!
SystemOrganization addCategory: #'Ma base additions-domains'!
SystemOrganization addCategory: #'Ma base additions-widgets'!
SystemOrganization addCategory: #'Ma base additions-Streams'!

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 5/20/2003 17:33'!
maUint: bits at: position put: anInteger

	bits = 32
		ifTrue:
			[ ^self
				unsignedLongAt: position + 1
				put: anInteger
				bigEndian: false ].
	bits = 16
		ifTrue:
			[ ^self
				unsignedShortAt: position + 1
				put: anInteger
				bigEndian: false ].
	bits = 8
		ifTrue:
			[ ^self
				byteAt: position + 1
				put: anInteger ].
	position + 1
		to: position + (bits // 8)
		do:
			[ :pos |
			self
				at: pos
				put: (anInteger digitAt: pos-position) ].
	^anInteger! !

!ByteArray methodsFor: '*ma base additions' stamp: 'cmm 5/20/2003 17:34'!
maUint: bits at: anInteger

	| answer bytes |
	bits = 32
		ifTrue:
			[ ^self
				unsignedLongAt: anInteger + 1
				bigEndian: false ].
	bits = 16
		ifTrue:
			[ ^self
				unsignedShortAt: anInteger + 1
				bigEndian: false ].
	bits = 8 
		ifTrue:
			[ ^self byteAt: anInteger + 1 ].
	bytes _ bits // 8.
	answer _ LargePositiveInteger new: bytes.
	1 to: bytes do:
		[ :digitPosition |
		answer
			digitAt: digitPosition
			put: (self at: digitPosition + anInteger) ].
	^answer normalize! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 8/19/2003 23:53'!
maCategory
	^ self actualClass organization categoryOfElement: methodSymbol! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 2/7/2002 23:41'!
maActualMethod

	| class |
	^(class _ self actualClass)
		ifNil: [ nil ]
		ifNotNil: [ class >> self methodSymbol ]
! !

!MethodReference methodsFor: '*ma base additions' stamp: 'cmm 8/19/2003 23:53'!
maSourceCode
	^ self actualClass sourceCodeAt: methodSymbol! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:46'!
maShallowCopy

	^self shallowCopy! !

Object subclass: #MaOverrider
	instanceVariableNames: 'overriders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaOverrider commentStamp: '<historical>' prior: 0!
I provide a list of objects a chance to handle a message and answer a non-nil before allowing the overridee a chance.  Primarily, I am intended to provide chain-of-responsibility for preferences.  A global preferences object is shared by most, but need to be selectively overridden.!

!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
addOverrider: anObject

	overriders add: anObject! !

!MaOverrider methodsFor: 'subclass responsibility' stamp: 'cmm 3/3/2004 22:54'!
overridee

	self subclassResponsibility! !

MaOverrider subclass: #MaSystemNavigationOverrider
	instanceVariableNames: ''
	classVariableNames: 'OriginalSystemNavigation'
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaSystemNavigationOverrider class methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:57'!
unload

	SystemNavigation maDefault: OriginalSystemNavigation ! !

!MaSystemNavigationOverrider class methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:56'!
initialize

	OriginalSystemNavigation _ SystemNavigation default! !

!MaSystemNavigationOverrider methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2004 22:56'!
overridee

	^ OriginalSystemNavigation! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 3/3/2004 22:53'!
doesNotUnderstand: aMessage

	overriders do:
		[ : each |
		(each respondsTo: aMessage selector)
			ifTrue: 
				[ | answer |
				answer _ aMessage sentTo: each.
				answer ifNotNil: [ ^ answer ] ] ].
	^ aMessage sentTo: self overridee! !

!MaOverrider methodsFor: 'private' stamp: 'cmm 7/1/2004 10:50'!
initialize
	super initialize.
	overriders := OrderedCollection new: 1! !

!MaOverrider methodsFor: 'building' stamp: 'cmm 3/3/2004 22:45'!
removeOverrider: anObject

	overriders remove: anObject! !

!Object methodsFor: '*ma base additions' stamp: ''!
maPrintAttribute: aSymbol on: aStream

	(self class allInstVarNames includes: aSymbol asString)
		ifTrue:
			[ self
				maPrintInstVar: aSymbol
				on: aStream ]
		ifFalse:
			[ self
				maPrintSelector: aSymbol
				on: aStream ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 2/14/2003 16:29'!
maIsSymbol

	^false! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 5/11/2003 22:16'!
maPrintSelector: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' : '.
	value :=
		[ self perform: aSymbol ]
			on: Error
			do: [ :exc | exc return: '**invalid**' ].
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]! !

!Object methodsFor: '*ma base additions' stamp: 'cm 12/29/2001 01:14'!
maPrintAbbreviatedOn: aStream
	"This is intended to support two possible string representations for any object
	instead of just one.  The normal one and this abbreivated one.  An abbreviated
	provides a brevity that proves useful when looking at collections or
	other 'container' type objects.

	Suggested usage is to omit the objects type (e.g. class name) for printing abbreviated,
	but include it for standard printOn:"
! !

!Object methodsFor: '*ma base additions' stamp: ''!
maInstSize
	"Answer the number of named and indexed instance variables referenced by
	the receiver."

	^self class instSize + self basicSize
! !

Object subclass: #MaObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!

MaObject subclass: #MaSingleton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-abstractions'!

MaSingleton class
	instanceVariableNames: 'current'!

!MaSingleton class methodsFor: 'accessing' stamp: ''!
current

	^current
! !

!MaSingleton class methodsFor: 'actions' stamp: 'cmm 2/2/2003 13:48'!
reset

	current _ self new! !

MaObject subclass: #MaStat
	instanceVariableNames: 'current min max total count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
min

	^min! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 12:10'!
setCurrent: aMagnitude

	current _ aMagnitude! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
count

	^count! !

!MaStat methodsFor: 'private' stamp: 'cmm 7/1/2004 10:51'!
initialize
	super initialize.
	count := 0! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
total

	^total! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
max

	^max! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 5/19/2003 14:20'!
mean

	^(total / count) asFloat! !

!MaStat methodsFor: 'building' stamp: 'cmm 2/4/2003 12:49'!
addCurrent: aMagnitude

	self setCurrent: aMagnitude.
	count _ count + 1.
	min _ min ifNil: [ aMagnitude ] ifNotNil: [ min min: aMagnitude ].
	max _ max ifNil: [ aMagnitude ] ifNotNil: [ max max: aMagnitude ].
	total _ total ifNil: [ aMagnitude ] ifNotNil: [ total + aMagnitude ]! !

!MaStat class methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2003 12:49'!
example

	| stat |
	stat _ self new.
	#(1 2 5 8 9 15) do: [ :each | stat addCurrent: each ].
	stat! !

!MaStat methodsFor: 'printing' stamp: 'cmm 5/11/2003 22:14'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(min max total count mean)
		on: aStream! !

!MaStat methodsFor: 'accessing' stamp: 'cmm 2/4/2003 11:53'!
current

	^current! !

!MaObject methodsFor: 'private' stamp: ''!
initialize

	"Default, do nothing."
! !

MaObject subclass: #MaTextMessage
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-domains'!

!MaTextMessage commentStamp: '<historical>' prior: 0!
This little tool helps you build non-wimpy message strings.!

!MaTextMessage methodsFor: 'private building' stamp: 'cmm 11/25/2003 00:17'!
appendString: anObject

	anObject isString 
		ifTrue: [ stream nextPutAll: anObject ] 
		ifFalse: [ anObject printOn: stream ]! !

!MaTextMessage methodsFor: 'private accessing' stamp: 'cmm 11/25/2003 00:16'!
string

	^stream contents! !

!MaTextMessage methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
messageText

	stream last = $. ifFalse: [ stream nextPut: $. ].
	^stream contents
! !

!MaTextMessage methodsFor: 'private initializing' stamp: 'cmm 11/25/2003 00:16'!
initialize

	super initialize.
	stream _ String new writeStream! !

!MaTextMessage methodsFor: 'private initializing' stamp: ''!
appendList: aCollection with: aString

	| index |

	aCollection isEmpty ifTrue: [ ^nil ].
	index := 1.
	aCollection do:
		[ :each |
		self append: each.
		aCollection size > 1
			ifTrue:
				[ index < (aCollection size - 1)
					ifTrue:
						[ self append: ', ' ]
					ifFalse:
						[ index = (aCollection size - 1) ifTrue: [ self append: aString ] ] ].
		index := index + 1 ]
! !

!MaTextMessage methodsFor: 'building' stamp: ''!
appendCount: aNumber of: aString
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self
		append: aNumber;
		space.
	self
		appendProperlyPluralized: aString
		for: aNumber
! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 11/25/2003 00:19'!
appendProperlyPluralized: aString for: aNumber
	"aString should be a non-plural word.  This method will append the
	plural version of aString (by simply adding 's') if aNumber is > 1."

	self append: aString.
	aString last asLowercase = $s
		ifTrue: [ stream nextPut: $' ]
		ifFalse: [ stream nextPut: $s ]! !

!MaTextMessage methodsFor: 'building' stamp: 'cmm 3/6/2002 22:47'!
append: aString

	self appendString: aString
! !

!MaTextMessage methodsFor: 'building' stamp: ''!
appendAndedList: aCollection

	self
		appendList: (
			aCollection
				collect: [ :each | each isString ifTrue: [ each ] ifFalse: [ each printString ] ])
		with: ' and '
! !

!MaTextMessage methodsFor: 'building' stamp: ''!
space

	self append: $ 
! !

!MaObject methodsFor: 'copying' stamp: 'cmm 4/23/2002 19:35'!
copyWithAttributes: anArray
	"anArray of instVar names in the receiver."

	| copy |

	^(copy := super copy)
		copyAttributes: anArray
		from: copy
! !

MaObject subclass: #MaFilename
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-File services'!

!MaFilename commentStamp: '<historical>' prior: 0!
This class is useful for accessing and manipulating file names and
individual components of a file name.

Anatomy of a filename (according to this class)
==============================

Our models to describe will be:

	Model A:  c:\temp\chris.sso
	Model B:  chris.sso

For Model A
-------------
#drive = 'c:'
#path = 'c:\temp'
#pathComponent = '\temp'
#base = 'c:\temp\chris'
#baseComponent = 'chris'
#extension = 'sso'
#fileName = 'chris.sso'
!

!MaFilename methodsFor: 'accessing' stamp: ''!
baseComponent

	^self hasExtension
		ifTrue:
			[ self string
				copyFrom: (self indexOfLastPathDelimiter + 1 max: 1)
				to: self indexOfDotDelimiter - 1 ]
		ifFalse:
			[ self string
				copyFrom: (self indexOfLastPathDelimiter + 1 max: 1)
				to: self size ]
! !

!MaFilename methodsFor: 'building' stamp: 'cmm 11/19/2003 22:47'!
baseComponent: aString

	self string: (
		(WriteStream on: String new)
			nextPutAll: self path;
			nextPut: self pathDelimiter;
			nextPutAll: aString;
			nextPut: self dotDelimiter;
			nextPutAll: self extension;
			contents)
! !

!MaFilename methodsFor: 'testing' stamp: ''!
hasDrive

	^self string size > 1 and: [ (self string at: 2) = self driveDelimiter ]
! !

!MaFilename methodsFor: 'accessing' stamp: ''!
fileName

	^self hasPath
		ifTrue:
			[ self string
				copyFrom: self indexOfLastPathDelimiter + 1
				to: self size ]
		ifFalse:
			[ self string ]
! !

!MaFilename methodsFor: 'accessing' stamp: 'cmm 12/23/2002 20:47'!
path

	^self hasPath
		ifTrue:
			[ self upTo: 'path' ]
		ifFalse:
			[ String maEmpty ]! !

!MaFilename methodsFor: 'accessing' stamp: ''!
size

	^self string size
! !

!MaFilename methodsFor: 'private' stamp: 'cmm 3/22/2004 18:00'!
dotDelimiter

	^ FileDirectory extensionDelimiter! !

!MaFilename methodsFor: 'building' stamp: ''!
extension: aString

	| base |

	base := self base.
	self string: (
		(WriteStream on: (String new: base size + self dotDelimiterSize + aString size))
			nextPutAll: base;
			nextPut: self dotDelimiter;
			nextPutAll: aString;
			contents)
! !

!MaFilename methodsFor: 'private' stamp: ''!
string

	^string! !

!MaFilename methodsFor: 'printing' stamp: ''!
printAbbreviatedOn: aStream

	aStream nextPutAll: self string
! !

!MaFilename methodsFor: 'building' stamp: ''!
path: aString

	self string: (
		(WriteStream on: String new)
			nextPutAll: aString;
			nextPut: self pathDelimiter;
			nextPutAll: self fileName;
			contents)
! !

!MaFilename methodsFor: 'private' stamp: ''!
driveDelimiter

	^$:
! !

!MaFilename methodsFor: 'testing' stamp: ''!
hasPath

	^(self string indexOf: self pathDelimiter) > 0
! !

!MaFilename methodsFor: 'creation' stamp: ''!
copyWithExtension: aString

	^self copy extension: aString
! !

!MaFilename methodsFor: 'private' stamp: ''!
string: aString

	string := aString
! !

!MaFilename methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:32'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self string
! !

!MaFilename methodsFor: 'accessing' stamp: 'cmm 12/23/2002 20:47'!
extension

	^self hasExtension
		ifTrue:
			[ self string
				copyFrom: self indexOfDotDelimiter + 1
				to: self size ]
		ifFalse:
			[ String maEmpty ]
! !

!MaFilename methodsFor: 'accessing' stamp: ''!
asString

	^self string
! !

!MaFilename methodsFor: 'private' stamp: 'cmm 5/11/2003 21:57'!
indexOfLastPathDelimiter

	^self string
		lastIndexOf: self pathDelimiter
		ifAbsent: [ 0 ]! !

!MaFilename methodsFor: 'private' stamp: ''!
indexOfFirstPathDelimiter

	^self string indexOf: self pathDelimiter
! !

!MaFilename methodsFor: 'private' stamp: 'cmm 5/11/2003 21:56'!
indexOfDotDelimiter

	^self string
		lastIndexOf: self dotDelimiter
		ifAbsent: [ 0 ]! !

!MaFilename methodsFor: 'private' stamp: 'cmm 2/25/2003 17:57'!
pathDelimiter

	^FileDirectory default pathNameDelimiter! !

!MaFilename class methodsFor: 'creation' stamp: ''!
fromString: aString
	"aString may be a simple filename.ext or a full path."

	^self new string: aString
! !

!MaFilename methodsFor: 'accessing' stamp: 'cmm 12/23/2002 20:47'!
pathComponent
	"Answer just the path component without the drive."

	^self hasPath
		ifTrue:
			[ self string
				copyFrom: self indexOfFirstPathDelimiter
				to: self indexOfLastPathDelimiter - 1 ]
		ifFalse:
			[ String maEmpty ]! !

!MaFilename methodsFor: 'accessing' stamp: 'cmm 12/23/2002 20:46'!
drive

	^self hasDrive
		ifTrue:
			[ self string
				copyFrom: 1
				to: 2 ]
		ifFalse:
			[ String maEmpty ]
! !

!MaFilename methodsFor: 'private' stamp: ''!
dotDelimiterSize

	^1
! !

!MaFilename methodsFor: 'testing' stamp: ''!
hasExtension

	^(self string indexOf: self dotDelimiter) > 0
! !

!MaFilename methodsFor: 'private' stamp: 'cmm 5/28/2003 10:26'!
upTo: componentName
	"Answer a copy of the receivers string with all of the components
	up to componentName.  The order of the components is:
	drive + path + base + extension.  The receiver must have a full
	path name including drive."

	| stream |

	componentName = 'extension' ifTrue: [ ^self string ].
	stream := WriteStream on: String new.
	stream nextPutAll: self drive.
	componentName = 'drive' ifTrue: [ ^stream contents ].
	stream nextPutAll: self pathComponent.
	componentName = 'path' ifTrue: [ ^stream contents ].
	stream size > 0 ifTrue: [ stream nextPut: self pathDelimiter ].
	stream nextPutAll: self baseComponent.
	^stream contents! !

!MaFilename methodsFor: 'private' stamp: 'cmm 12/23/2002 20:47'!
initialize

	super initialize.
	string := String maEmpty
! !

!MaFilename methodsFor: 'accessing' stamp: ''!
base

	^self upTo: 'base'
! !

!MaObject methodsFor: 'copying' stamp: 'cmm 12/19/2002 23:23'!
copyAttributes: anArray from: sourceObject

	anArray do:
		[ :each |
		self
			instVarNamed: each asString
			put: (sourceObject instVarNamed: each) copy ]! !

!MaObject methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self maPrintAbbreviatedOn: aStream
! !

!Object methodsFor: '*ma base additions' stamp: ''!
maPrintAttributes: arrayOfSymbols on: aStream

	arrayOfSymbols do:
		[ :each |
		self
			maPrintAttribute: each
			on: aStream ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 1/24/2002 14:05'!
maIsClass

	^false
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 23:26'!
maPrintInstVar: aSymbol on: aStream

	| value |

	aStream
		cr;
		tab;
		nextPutAll: aSymbol;
		nextPutAll: ' = '.
	value := self instVarNamed: aSymbol asString.
	(value isCollection and: [ value isString not ])
		ifTrue:
			[ value do:
				[ :each |
				aStream
					maPrint: each;
					space ] ]
		ifFalse:
			[ aStream maPrint: value ]
! !

!Object methodsFor: '*ma base additions' stamp: 'cmm 6/11/2004 16:07'!
maMarked: aString
	"This is a marker method used to indicate that we wish to come back and re-examine
	code in the future for possible improvement.  For now, try to keep improvements categorized
	via anEsAtom that we can Browse References to, if necessary.  The possibilities should be:

		'ugly'
		'performance'
		'bug'
		'dev'
		'vmSpecific'
		'releaseSpecific'
		'system override'
		'deprecated'
		'magic'
	A *comment* then should follow to provide more detail."

	
aString = 'delete' ifTrue: [ self halt: 'Oops..  looks like you still need this method.' ]! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 12/30/2003 23:43'!
maAfter: anObject ifError: aBlock
	"A more-flexible substitute for after:ifAbsent: which, if anObject is the last object in me, errors out instead of calling the ifAbsent block.  This version does, making your code cleaner."

	self last == anObject ifTrue: [ ^ aBlock value ].
	^self
		after: anObject
		ifAbsent: aBlock! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 5/18/2004 12:01'!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection and in the same order."

	self == anotherCollection ifTrue: [ ^ true ].
	self size = anotherCollection size ifFalse: [ ^false ].
	self
		with: anotherCollection
		do: [ :eachInSelf :eachInOther | eachInSelf = eachInOther ifFalse: [ ^false ] ].
	^true
! !

!SequenceableCollection methodsFor: '*ma base additions' stamp: 'cmm 12/30/2003 23:44'!
maBefore: anObject ifError: aBlock
	"A more-flexible substitute for before:ifAbsent: which, if anObject is the last object in me, errors out instead of calling the ifAbsent block.  This version does, making your code cleaner."

	self first == anObject ifTrue: [ ^ aBlock value ].
	^self
		before: anObject
		ifAbsent: aBlock! !

!LimitedWriteStream methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:02'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!LimitedWriteStream methodsFor: '*ma base additions' stamp: 'cmm 2/5/2003 19:47'!
maPrintNumber: anInteger template: templateString

	self maMarked: 'dev'.
	"Currently supports Integers.  If you're hogging this name, you should be able to interpret all Numbers."
	templateString size - anInteger printString size timesRepeat: [ self nextPut: $0 ].
	anInteger maPrintAbbreviatedOn: self! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:20'!
maRemoveAll
	"Efficiently removes all elements in the receiver."

	self setContents: (self class contentsClass new: contents size)! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 1/23/2002 00:18'!
printOn: aStream

	aStream
		nextPutAll: (self class name first isVowel ifTrue: [ 'an ' ] "$NON-NLS$" ifFalse: [ 'a ' ]). "$NON-NLS$"
	self class printOn: aStream.
	contents keysAndValuesDo:
		[ :eachKey :eachValue |
		aStream
			cr; tab;
			nextPut: $(;
			maPrint: eachValue;
			nextPutAll: ') ';
			maPrint: eachKey ]
! !

!Bag methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:33'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:45'!
maShallowCopy

	| copy |
	copy _ self species new.  "new: seems buggy w/ Dictionaries.."
	self keysAndValuesDo: 
		[ :eachKey :eachValue | copy at: eachKey put: eachValue ].
	^copy! !

!Dictionary methodsFor: '*ma base additions' stamp: ''!
maAt: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock

	| current uniqueObj |

	uniqueObj := 'x'.
	^(current := self
		at: anObject
		ifAbsent: [ uniqueObj ]) == uniqueObj
			ifTrue: [ zeroArgBlock value ]
			ifFalse: [ oneArgBlock value: current ]
! !

!Dictionary methodsFor: '*ma base additions' stamp: ''!
maAllKeysAtValue: anObject

	| aCollection |

	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection! !

!Dictionary methodsFor: '*ma base additions' stamp: 'cmm 9/27/2003 19:40'!
maDeepCopy

	| answer |
	answer _ self species new.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		answer at: eachKey copy put: eachValue copy ]! !

Morph subclass: #MaProgressBarMorph
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-widgets'!

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2003 00:23'!
percent: aFloat "between 0.0 and 1.0"

	| secureFloat |
	secureFloat _ aFloat > 1.0 ifTrue: [ 1.0 ] ifFalse: [ aFloat < 0.0 ifTrue: [ 0.0 ] ifFalse: [ aFloat ] ].
	bar width: self width*secureFloat! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 11/12/2003 22:59'!
initialize

	super initialize.
	self
		extent: 100@12;
		color: Color gray;
		layoutPolicy: TableLayout new;
		position: 100@100.
	bar _ RectangleMorph new
		color: Color green;
		extent: 0@self height;
		layoutInset: 0;
		position: 0@0;
		setBorderStyle: #complexRaised;
		vResizing: #spaceFill;
		yourself.
	self percent: 0.0.
	self addMorph: bar! !

!MaProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'cmm 7/19/2004 23:52'!
veryDeepInner: aDeepCopier

	super veryDeepInner: aDeepCopier.
	bar _ bar veryDeepCopyWith: aDeepCopier! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:40'!
maOn: exc1 do: block1 on: exc2 do: block2

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		on: exc2
		do: block2! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 3/23/2003 22:43'!
maOn: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		[ self value ]
			on: exc1
			do: block1 ]

		maOn: exc2
		do: block2

		on: exc3
		do: block3! !

!BlockContext methodsFor: '*ma base additions' stamp: 'cmm 12/5/2002 21:43'!
maBench
	"See how many times I can value in 5 seconds.  I'll answer a meaningful description."

	| startTime endTime count |
	count _ 0.
	endTime _ Time millisecondClockValue + 5000.
	startTime _ Time millisecondClockValue.
	[ Time millisecondClockValue > endTime ] whileFalse: [ self value.  count _ count + 1 ].
	endTime _ Time millisecondClockValue.
	^count = 1
		ifTrue: [ ((endTime - startTime) // 1000) printString, ' seconds.' ]
		ifFalse:
			[ ((count * 1000) / (endTime - startTime)) asFloat printString, ' per second.' ]! !

!TimeProfileBrowser class methodsFor: '*ma base additions' stamp: 'cmm 12/24/2003 13:25'!
maOnBlock: block if: conditionBlock
	"Allows you to build up your sample set before invoking the profiler."
	^conditionBlock value 
		ifTrue: [ self onBlock: block ]
		ifFalse: [ block value ]! !

!FileDirectory methodsFor: '*ma base additions' stamp: 'cmm 4/8/2002 20:52'!
maEntriesMatching: pat
	"FileDirectory default fileNamesMatching: '*'"

	^ self entries select: [ :each | pat match: each name ]
! !

PackageInfo subclass: #MaBaseAdditionsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma base additions-Info'!

!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:05'!
prerequisitePackages

	^#('Ma exception handling')! !

!MaBaseAdditionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:19'!
readmeText

	^'I consist of just over 50 method extensions that all begin with the letters "ma".  These are methods that I needed for one or more of the other "Ma" frameworks, but felt it was general enough to be useful to other programs.

I have an abstract MaObject and MaSingleton.  Also noteworthy is a new PluggableListMorphOfMany, called MaPluggableListMorphOfMany.  This is the improved one used by the Tracing Messages Browser that supports better swipe-selecting and shift-range selecting.

For details on other additions, see <PackageInfo named: self default packageName>.'! !

!SystemNavigation class methodsFor: '*ma base additions' stamp: 'cmm 3/3/2004 22:57'!
maDefault: aSystemNavigation

	Default _ aSystemNavigation! !

!Symbol methodsFor: '*ma base additions' stamp: 'cmm 2/14/2003 16:29'!
maIsSymbol

	^true! !

!Number methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:40'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !

!Class methodsFor: '*ma base additions' stamp: 'cmm 1/24/2002 14:04'!
maIsClass

	^true
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 2/5/2003 19:47'!
maPrintNumber: anInteger template: templateString

	self maMarked: 'dev'.
	"Currently supports Integers.  If you're hogging this name, you should be able to interpret all Numbers."
	templateString size - anInteger printString size timesRepeat: [ self nextPut: $0 ].
	anInteger maPrintAbbreviatedOn: self! !

!WriteStream methodsFor: '*ma base additions' stamp: ''!
maPrint: anObject

	anObject isString ifTrue: [ self nextPutAll: anObject ] ifFalse: [ anObject printOn: self ]
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:03'!
maPrintAbbreviated: aMaObject

	aMaObject maPrintAbbreviatedOn: self
! !

!WriteStream methodsFor: '*ma base additions' stamp: 'cmm 11/10/2002 20:35'!
endEntry
	"No-op for compatibility with TranscriptStream."! !

!CompiledMethod methodsFor: '*ma base additions' stamp: 'cmm 2/17/2002 16:16'!
maMethodClass

	^self who first
! !

!CompiledMethod methodsFor: '*ma base additions' stamp: 'cmm 7/3/2003 12:31'!
maSourceString

	^(self
		getSourceFor: self selector
		in: self maMethodClass) asString! !

!Interval methodsFor: '*ma base additions' stamp: ''!
maIntersects: anInterval 
	"Return true if the receiver overlaps with anInterval."

	^(self from between: anInterval from and: anInterval to) 
		or: [anInterval from between: self from and: self to]! !

!Rectangle methodsFor: '*ma base additions' stamp: 'cmm 8/25/2003 23:42'!
maPointAtRandom

	^(self topLeft x + self width atRandom) @ (self topLeft y + self height atRandom)! !

!ReadStream methodsFor: '*ma base additions' stamp: 'cmm 7/1/2003 22:12'!
maUpToIncluding: anObject

	| start end |
	start _ position+1.
	end _ collection indexOf: anObject startingAt: start ifAbsent: [ 0 ].

	"not present--return rest of the collection"	
	end = 0 ifTrue: [ ^self upToEnd ].

	"skip to the end and return the data passed over"
	position _ end.
	^collection copyFrom: start to: end! !

!OrderedCollection methodsFor: '*ma base additions' stamp: 'cm 1/7/2002 16:25'!
maAddAll: aSequenceableCollection afterIndex: integerIndex

	aSequenceableCollection reverseDo: [:each | self add: each afterIndex: integerIndex ].
	^aSequenceableCollection
! !

!OrderedCollection methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:33'!
maRemoveAll

	self setCollection: (Array new: self size)! !

!Character methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:44'!
maShallowCopy
	"Characters are unique."

	^self
! !

!String methodsFor: '*ma base additions' stamp: 'cmm 1/23/2002 01:24'!
maEndsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase endsWith: aString asLowercase ]
		ifFalse:
			[ self endsWith: aString ]! !

!String methodsFor: '*ma base additions' stamp: 'cmm 1/28/2003 11:57'!
maFormattedForPlural: aNumber
	"This is kind of a wing-nut method, but it can save you some
	redundant code if you care to make your programs user message
	plural and singular friendly.  It will add or remove an s based on
	aNumber and whether or not the receiver already ends in s."

	^aNumber > 0 & (aNumber <= 1)
		ifTrue:
			[ "should not end in s"
			(self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ self
							copyFrom: 1
							to: self size - 1 ]
					ifFalse:
						[ self ] ]
		ifFalse:
			[ (self
				maEndsWith: 's'
				ignoringCase: true)
					ifTrue:
						[ "should end in s"
						self ]
					ifFalse:
						[ self , 's' ] ]! !

!String class methodsFor: '*ma base additions' stamp: 'cmm 1/28/2003 15:51'!
maEmpty
	"Using a canonical empty String can reduce object-count in memory or a large Magma database."

	^''! !

!String methodsFor: '*ma base additions' stamp: ''!
maAsIntegerFromRadix: anInteger
	"Answer a Smalltalk Integer with an equivalent value of the receiver
	represented in radix anInteger."

	^self
		inject: 0
		into: [ :sum :character | (sum * anInteger) + character digitValue ]
! !

!String methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 23:32'!
maBeginsWith: aString ignoringCase: aBoolean

	"Returns true if the receiver begins with the elements in aString,
	while ignoring the case if aBoolean is true."

	^aBoolean
		ifTrue:
			[ self asLowercase beginsWith: aString asLowercase ]
		ifFalse:
			[ self beginsWith: aString ]! !

!String methodsFor: '*ma base additions' stamp: 'cm 12/24/2001 16:39'!
maPrintAbbreviatedOn: aStream

	self printOn: aStream
! !

!Collection methodsFor: '*ma base additions' stamp: ''!
maMatchesElementsOf: anotherCollection
	"Answer whether the receiver points to equivalent objects as
	anotherCollection.  In SequencableCollections, the order must be
	the same as well."

	^self maConsistsOf: anotherCollection
! !

!Collection methodsFor: '*ma base additions' stamp: ''!
maRemoveAll: aCollection forEachAbsent: aBlock

	^aCollection do:
		[ :element |
		self
			remove: element
			ifAbsent: [ aBlock value: element ] ]
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 12/19/2002 21:32'!
maIncludesAll: aCollection
	"Return true if the receiver includes all elements in aCollection.
	If aCollection contains duplicate elements, the receiver must have
	one for each of them."

	| otherColl |

	aCollection size > self size ifTrue: [ ^false ].
	self size > 20
		ifTrue:
			[ ^self asBag maIncludesAll: aCollection ].
	otherColl :=
		aCollection size > 20
			ifTrue: [ aCollection asBag ]
			ifFalse: [ aCollection ].
	otherColl do:
		[ :each | (self occurrencesOf: each) < (otherColl occurrencesOf: each) ifTrue: [ ^false ] ].
	^true! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 1/16/2002 16:48'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 20:29'!
maRemoveAll
	"Efficiently removes all elements from the receiver."

	self init: self size! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 9/27/2003 19:46'!
maDeepCopy
	"Squeak, in my opinion, does not make deepCopies of Collections consistent with other objects."

	^self collect: [ : each | each copy ]! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/24/2004 01:05'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 12/17/2002 14:21'!
maIncludesAllUnique: aCollection
	"Return true if the receiver includes at least one of
	each unique element in aCollection."

	| compareCollection |

	compareCollection :=
		aCollection size > 20
			ifTrue:
				[ aCollection ]
			ifFalse:
				[ aCollection asSet ].
	self do: [ :each | (compareCollection includes: each) ifFalse: [ ^false ] ].
	^true! !

!Collection methodsFor: '*ma base additions' stamp: 'cmm 7/9/2002 22:59'!
maConsistsOf: aCollection
	"Answer whether the receiver and aCollection reference all equal
	objects, including the same number of references to those objects.  Order
	is not a factor."

	^self size = aCollection size and: [ self maIncludesAll: aCollection ]
! !

!Message methodsFor: '*ma base additions' stamp: 'cmm 7/10/2003 23:12'!
maArguments: anArray

	args _ anArray! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 1/24/2002 13:52'!
maClearBit: index

	"Return the receiver with the bit at index clear."

	^self bitAnd: (1 bitShift: index - 1) bitInvert! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 1/24/2002 13:52'!
maSetBit: index

	"Return the receiver with the bit at index set."

	^self bitOr: (1 bitShift: index - 1)! !

!Integer methodsFor: '*ma base additions' stamp: 'cmm 2/15/2002 00:24'!
maIsBitSet: bitPosition

	^self allMask: (2 raisedTo: bitPosition-1)
! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 11/19/2003 22:48'!
maFirstCommentAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	^(self methodDict includesKey: selector)
		ifTrue: [ self firstCommentAt: selector ]
		ifFalse: [ self superclass maFirstCommentAt: selector ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 11/19/2003 22:53'!
maFirstCommentOrNilAt: selector
	"A much more-convenient method than firstCommentAt:, which requires you to specify the exact class, a problem when the method is implemented in the superclass methodDict."

	| string |
	^(string _ self maFirstCommentAt: selector) isEmpty
		ifTrue: [ nil ]
		ifFalse: [ string ]! !

!Behavior methodsFor: '*ma base additions' stamp: 'cmm 2/20/2004 17:59'!
maLowestCommonSuperclassWith: aClass

	| startClass other |
	self allSuperclasses size > aClass allSuperclasses size
		ifTrue: [ startClass _ aClass.  other _ self. ]
		ifFalse: [ startClass _ self.  other _ aClass ].
	startClass withAllSuperclassesDo:
		[ : each |
		(other inheritsFrom: each)
			ifTrue:
				[ ^ each ] ].
	MaSoftwareError signal: 'Didn''t expect to not find a common supeclass.'! !

!Set methodsFor: '*ma base additions' stamp: ''!
maIncludesAllUnique: aCollection

	aCollection do: [ :each | (self includes: each) ifFalse: [ ^false ] ].
	^true
! !

!Set methodsFor: '*ma base additions' stamp: 'cmm 7/24/2002 20:41'!
maShallowCopy

	| copy |
	copy _ self species new: self size.
	self do: [ :each | copy add: each ].
	^copy! !

!Set methodsFor: '*ma base additions' stamp: 'cmm 10/23/2002 22:01'!
maRemoveAll
	"Efficiently removes all elements from the receiver."

	self init: (self size max: 4)! !
MaSystemNavigationOverrider initialize!
